#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

struct Item {
	Item(int s, int n){
		this->step = s;
		this->number = n;
	}
    int step;
	int number;
}

bool isSudy(int a){
	return (a%2 == 0);
}
bool isLichy(int a){
	return (a%2 == 1);
}

bool search(int oa, int ob, vector<Item> &a, vector<Item> &b){
	for(int i=0; i<a.size();i++){
		for(int j=0; j<b.size();j++){
			if (a[i].number == b[j].number){
				printf("%d needs %d steps, %d needs %d steps, they meet at %d\n",oa,a[i].steps,ob,b[j].steps,a[i].number);
				return true;
			}
		}
	}
	return false;			
}
void recursion(int oa, int ob, int na, int nb,int steps, vector<Item> &a, vector<Item> &b){
	a.push_back(Item(steps,na));
	b.push_back(Item(steps,nb))
	if (search(oa, ob, a, b))
		return;	

	if (a == 1 || b == 1){	
		if (a == 1 && isLichy(b))
			recursion(oa, ob, a, 3*b+1, ++steps, a, b);
		if (a == 1 && isSudy(b))
			recursion(oa, ob,  a, b/2, ++steps, a, b);
		if (b == 1 && isLichy(a))
			recursion(oa, ob,  3*a+1, b, ++steps, a, b);
		if (b == 1 && isSudy(a))
			recursion(oa, ob, a/2, b, ++steps, a, b);
		return;
	}
	

	if (isSudy(a) && isLichy(b)){
		recursion(oa, ob,  a/2, 3*b+1, ++steps, a, b);
	}
	if (isLichy(a) && isLichy(b)){
		recursion(oa, ob,  3*a+1, 3*b+1, ++steps, a, b);
	}
	if (isSudy(a) && isSudy(b)){
		recursion(oa, ob,  a/2, b/2, ++steps, a, b);
	}
	if (isLichy(a) && isSudy(b)){
		recursion(oa, ob,  3*a+1, b/2, ++steps, a, b);
	}

	return;
}


void collatz(int a, int b){

	if (a == b){
		printf("%d needs %d steps, %d needs %d steps, they meet at %d\n",0,0,0,0,a);
		return;
	}

	//vector<Item> *va = new vector<Item>;
	//vector<Item> *vb = new vector<Item>;
	vector<Item> a;
	vector<Item> b;
	recursion(a, b, a, b, 0,  va, vb);
	//delete va;
	//delete vb;
}


int main(){
	while (1){
		int a = 0;
		int b = 0;
		scanf("%d %d", &a, &b);

		if (a == 0 && b == 0)
			break;
		collatz (a,b);
	}
	return 0;
}
